﻿package 
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.FullScreenEvent;
	import flash.events.MouseEvent;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.filters.BitmapFilter;
	import flash.filters.BitmapFilterQuality;
	import flash.filters.GlowFilter;
	

	public class Zoomer extends Sprite
	
	{
		private var drawer:Sprite;
		private var data:BitmapData;
		private var background:Bitmap;
		private var cloned:BitmapData;
		private var upground:Bitmap;
		private var counter:Number = 1;
		public function Zoomer()
		{
				addEventListener(Event.ADDED_TO_STAGE,addedHandler);
		}
		
		private function Bitmapfilter():BitmapFilter
		{
			var color:Number = Math.random()*0xfe0404;
			var alpha:Number = 300;
			var blurx:Number = 200;
			var blury:Number = 300;
			var strenght:Number = 400;
			var inner:Boolean = false;
			var knockout:Boolean = false;
			var quality:Number = BitmapFilterQuality.HIGH;
			return new(color, alpha, blurx, blury, strenght,quality);
			}
			
		private function addedHandler(e:Event):void
		{
			setup();
			stage.addEventListener(FullScreenEvent.FULL_SCREEN,fullhandler);
			stage.addEventListener(MouseEvent.MOUSE_MOVE,down_handler);
			stage.addEventListener(MouseEvent.MOUSE_UP,up_handler);
		}
		
		private function fullhandler(e:FullScreenEvent):void
		{
			while(numChildren>0){
				this.removeChildAt(0);
			}
			data = null;
		}
		
		private function setup():void
		{
			data = new BitmapData(stage.stageWidth,stage.stageHeight,true,Math.random()*0xfe0404);
			background = new Bitmap(data);
			addChild(background);
		}
		
		private function down_handler(e:MouseEvent):void
		{
			addEventListener(Event.ENTER_FRAME, enterHandler);
		}
		private function up_handler(e:MouseEvent):void
		{
			removeEventListener(Event.ENTER_FRAME,enterHandler);
			setup();
		}
		
		private function enterHandler(e:Event):void
		{
			if(data == null){
				setup();
			}
			if(counter>Math.random()*180){
				counter = 100;
			}else{
				counter=counter/10;
			}
			var my_drawer:Sprite = buildDrawer();
			var support:Sprite = new Sprite();
			my_drawer.x = mouseX;
			my_drawer.y = mouseY;
			my_drawer.scaleX=my_drawer.scaleY= -scaleX/Math.random()*-1;
			support.addChild(my_drawer);
			data.draw(support);1
			cloned = data.clone();
			var mul:uint = Math.random()*0x80;
			data.merge(cloned,new Rectangle(0,0,stage.stageWidth,stage.stageHeight),new Point(counter,counter-Math.random()*5),mul,mul,mul,mul);
			//flash.display.BitmapData.getPixel(x;5,y:5):
		}
		private function buildDrawer():Sprite
		{
			drawer = new Sprite();
			drawer.graphics.beginFill(Math.random()*0xfe0404,.10);
			drawer.graphics.drawCircle(-stage.stageWidth/2+150,-stage.stageHeight/1,Math.random()*20);
			drawer.rotation = Math.random()*360;
			drawer.graphics.drawCircle(-stage.stageWidth/20,-stage.stageHeight/2+150,Math.random()*30)
			drawer.rotation = Math.random()*300;;
			drawer.graphics.beginFill(Math.random()*0xff6cff,.3);
			drawer.graphics.drawCircle(stage.stageWidth/20-10,-stage.stageHeight/1,Math.random()*20);
			drawer.rotation = Math.random()*36;
			drawer.graphics.beginFill(Math.random()*0x7f00ff,.34);
			drawer.graphics.drawCircle(-stage.stageWidth/5,stage.stageHeight/2-10,Math.random()*40);
			drawer.graphics.drawCircle(stage.stageWidth/20+100,-stage.stageHeight/10,Math.random()*40);
			drawer.rotation = Math.random()*360;
			drawer.graphics.endFill();
			drawer.rotation = Math.random()*100;
			return drawer;
		}
		
	}
}